ORIGIN = PWB
ORIGIN_VER = 2.1.49
PROJ = boulder
PROJFILE = boulder.mak
DEBUG = 0

ASM  = ml
H2INC  = h2inc
AFLAGS_G  = /Cx /W2 /WX
AFLAGS_D  = /Zi
AFLAGS_R  = /nologo
CC  = wcc386
CFLAGS_G  = /W2 /DDEBUG
CFLAGS_D  = /Od /d2
CFLAGS_R  = /Oneatx 
CXX  = wpp386
CXXFLAGS_G  = /W2 /DDEBUG
CXXFLAGS_D  = /d2 /Od
CXXFLAGS_R  = /Oneatx
MAPFILE_D  = NUL
MAPFILE_R  = NUL
LFLAGS_D  = D A 
LINKER  = wlink
ILINK  = ilink
LRF  = echo > NUL
ILFLAGS  = /a /e
BC  = bc
BCFLAGS_R  = /Ot
BCFLAGS_D  = /D /Zi
BCFLAGS_G  = /O /G2 /Fpi /Lr

FILES  = boulder.cpp graphics.cpp SPEEDUP.ASM animate.cpp FLAMES.CPP\
        EVENTS.CPP menu.cpp LEVELED.CPP KB_ASM.ASM KBD2.CPP mouse.cpp
OBJS  = boulder.obj graphics.obj SPEEDUP.obj animate.obj FLAMES.obj EVENTS.obj\
        menu.obj LEVELED.obj KB_ASM.obj KBD2.obj mouse.obj

all: $(PROJ).exe

.SUFFIXES:
.SUFFIXES:
.SUFFIXES: .obj .asm .cpp

boulder.obj : boulder.cpp boulder.h mouse.h
!IF $(DEBUG)
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_D) /Foboulder.obj boulder.cpp
!ELSE
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_R) /Foboulder.obj boulder.cpp
!ENDIF

graphics.obj : graphics.cpp boulder.h mouse.h
!IF $(DEBUG)
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_D) /Fographics.obj graphics.cpp
!ELSE
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_R) /Fographics.obj graphics.cpp
!ENDIF

SPEEDUP.obj : SPEEDUP.ASM
!IF $(DEBUG)
        $(ASM) /c $(AFLAGS_G) $(AFLAGS_D) /FoSPEEDUP.obj SPEEDUP.ASM
!ELSE
        $(ASM) /c $(AFLAGS_G) $(AFLAGS_R) /FoSPEEDUP.obj SPEEDUP.ASM
!ENDIF

animate.obj : animate.cpp boulder.h mouse.h
!IF $(DEBUG)
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_D) /Foanimate.obj animate.cpp
!ELSE
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_R) /Foanimate.obj animate.cpp
!ENDIF

FLAMES.obj : FLAMES.CPP boulder.h mouse.h
!IF $(DEBUG)
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_D) /FoFLAMES.obj FLAMES.CPP
!ELSE
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_R) /FoFLAMES.obj FLAMES.CPP
!ENDIF

EVENTS.obj : EVENTS.CPP boulder.h mouse.h
!IF $(DEBUG)
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_D) /FoEVENTS.obj EVENTS.CPP
!ELSE
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_R) /FoEVENTS.obj EVENTS.CPP
!ENDIF

menu.obj : menu.cpp boulder.h mouse.h
!IF $(DEBUG)
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_D) /Fomenu.obj menu.cpp
!ELSE
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_R) /Fomenu.obj menu.cpp
!ENDIF

LEVELED.obj : LEVELED.CPP boulder.h mouse.h
!IF $(DEBUG)
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_D) /FoLEVELED.obj LEVELED.CPP
!ELSE
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_R) /FoLEVELED.obj LEVELED.CPP
!ENDIF

KB_ASM.obj : KB_ASM.ASM
!IF $(DEBUG)
        $(ASM) /c $(AFLAGS_G) $(AFLAGS_D) /FoKB_ASM.obj KB_ASM.ASM
!ELSE
        $(ASM) /c $(AFLAGS_G) $(AFLAGS_R) /FoKB_ASM.obj KB_ASM.ASM
!ENDIF

KBD2.obj : KBD2.CPP boulder.h mouse.h
!IF $(DEBUG)
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_D) /FoKBD2.obj KBD2.CPP
!ELSE
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_R) /FoKBD2.obj KBD2.CPP
!ENDIF

mouse.obj : mouse.cpp mouse.h
!IF $(DEBUG)
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_D) /Fomouse.obj mouse.cpp
!ELSE
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_R) /Fomouse.obj mouse.cpp
!ENDIF


$(PROJ).exe : $(OBJS)
!IF $(DEBUG)
        $(LRF) @<<$(PROJ).lrf
$(LFLAGS_G) $(LFLAGS_D) F $(OBJS: = ^,) N $(PROJ)
<<
!ELSE
        $(LRF) @<<$(PROJ).lrf
$(LFLAGS_G) $(LFLAGS_R) F $(OBJS: = ^,) N $(PROJ)
<<
!ENDIF
        $(LINKER) @$(PROJ).lrf


.asm.obj :
!IF $(DEBUG)
        $(ASM) /c $(AFLAGS_G) $(AFLAGS_D) /Fo$@ $<
!ELSE
        $(ASM) /c $(AFLAGS_G) $(AFLAGS_R) /Fo$@ $<
!ENDIF

.cpp.obj :
!IF $(DEBUG)
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_D) /Fo$@ $<
!ELSE
        $(CXX) $(CXXFLAGS_G) $(CXXFLAGS_R) /Fo$@ $<
!ENDIF


run: $(PROJ).exe
        $(PROJ).exe $(RUNFLAGS)

debug: $(PROJ).exe
        WD -tr=rsi -nomouse $(CVFLAGS) $(PROJ).exe $(RUNFLAGS)
