//###################################################################
//# die ganzen verdammten event-routinen
//###################################################################
//-------------------------------------------------------------------

#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <graph.h>

#include "boulder.h"

//###################################################################
//# Interne Structs
//###################################################################
struct event_list_entry
{
   struct pos pos;
   struct event_list_entry *next;
};
struct event_list
{
   struct event_list_entry *entry;
   struct event_list *next;
};

//#
//# Interne Vars
//###################################################################
struct event_list *events = NULL;

//#
//# Interne Funktionen
//###################################################################
void green_slime_morph();


//###################################################################
//# void init_events_add()
//# wird von init_events aufgerufen....
//###################################################################
void init_events_add(int x, int y)
{
   struct event_list_entry *ptr;
   if (events == NULL)
   {
      events = (struct event_list *) my_alloc(sizeof(struct event_list));
      events->next = NULL;
      events->entry = NULL;
   }
   ptr = (struct event_list_entry *)
                 my_alloc(sizeof(struct event_list_entry));
   ptr->next = events->entry;
   events->entry = ptr;
   ptr->pos.x = x;
   ptr->pos.y = y;

}

//###################################################################
//# void init_events()
//# am Anfang alles einmal durchsuchen und event-liste aufstellen
//###################################################################
void init_events()
{
   int x,y;

   anz_green_slime = 0;
   anz_collected_dias = 0;
   for (x=0;x<FELD_AUFL_X;x++)
      for (y=0;y<FELD_AUFL_Y;y++)
      {
        switch (feld[y][x].inhalt)
        {
           case empty:
           case earth:
           case wall:
           case steel:
                break;
           case in:
                hero_x = x;
                hero_y = y;
                feld[y][x].counter = 50;
                init_events_add(x,y);
           case hero:
                hero_x = x;
                hero_y = y;
                init_events_add(x,y);
                break;
           case green_slime:
                anz_green_slime++;
                init_events_add(x,y);
                break;
           case blue_slime:
                feld[y][x].counter = 50;
                init_events_add(x,y);
                break;
           default:
                init_events_add(x,y);
                break;

        }
      }
   green_slime_im_level = (anz_green_slime > 0);
}

//###################################################################
//# void new_event(int x,int y)
//###################################################################
void new_event(int x,int y)
{
   struct event_list_entry *ptr;
   BYTE schon_da = FALSE;
   if (feld[y][x].inhalt != empty
       && feld[y][x].inhalt != earth
       && feld[y][x].inhalt != steel)
   {
      // *** x,y Paar bereits eingetragen ?
      ptr = events->next->entry;
      while (ptr)
      {
        if (ptr->pos.x == x && ptr->pos.y == y)
           schon_da = TRUE;
        ptr = ptr->next;
      }
      if (!schon_da) // neu?
      {
         ptr = (struct event_list_entry *)
                    my_alloc(sizeof(struct event_list_entry));
         ptr->next = events->next->entry;
         events->next->entry = ptr;
         ptr->pos.x = x;
         ptr->pos.y = y;
      }
   }
}

//###################################################################
//# etwas_fiel(x,y)                                                 #
//###################################################################
void etwas_fiel(short x, short y)
{
   switch(feld[y+1][x].inhalt) // auf wen denn?
   {
      case hero:
         feld[y+1][x].inhalt = bald_explo_nix;
         new_event(x,y+1);
         break;
      case fire_cracker:
         feld[y+1][x].inhalt = bald_explo_nix;
         new_event(x,y+1);
         break;
      case butter_fly:
         feld[y+1][x].inhalt = bald_explo_dia;
         new_event(x,y+1);
         break;
      case green_bomb:
      case red_bomb:
      case bomb_cross:
         feld[y+1][x].inhalt = bald_explo_nix;
         new_event(x,y+1);
         break;
      case empty:
         break;
      default:
         // was fiel ?
         switch (feld[y][x].inhalt)
         {
            case green_bomb:
                feld[y][x].aussehen++;
                setze_spiel_element( x<<4, y<<4, feld[y][x].aussehen);
                if (feld[y][x].aussehen - feld[y][x].inhalt >= 11)
                {
                   feld[y][x].inhalt = bald_explo_nix;
                   new_event(x,y);
                }
                break;
            case red_bomb:
            case bomb_cross:
                feld[y][x].inhalt = bald_explo_nix;
                new_event(x,y);
                break;
         }
   }
}

//###################################################################
//# feld_schieben(y,x,-1)
//# falls shift_flag = TRUE -> nur schieben, aber neuen Platz nicht
//#                            auch noch einnehmen
//###################################################################
void feld_schieben(int y, int x, int dx, char shift_flag)
{
   if (feld[y][x+dx+dx].inhalt == empty)
      switch (feld[y][x+dx].inhalt)
      {
          case stone:
          case red_bomb:
          case green_bomb:
          case bomb_cross:
             feld[y][x+dx+dx] = feld[y][x+dx];

             if (shift_flag)
             {
                feld[y][x+dx].inhalt = empty;
                feld[y][x+dx].aussehen = empty;
                setze_spiel_element( (x+dx)<<4, y<<4, empty);
                setze_spiel_element( (x+dx+dx)<<4, y<<4, feld[y][x+dx+dx].aussehen);
             }
             else
             {
                feld[y][x+dx] = feld[y][x];
                feld[y][x].inhalt = empty;
                feld[y][x].aussehen = empty;
                setze_spiel_element( x<<4, y<<4, empty);
                setze_spiel_element( (x+dx)<<4, y<<4, feld[y][x+dx].aussehen);
                setze_spiel_element( (x+dx+dx)<<4, y<<4, feld[y][x+dx+dx].aussehen);
                hero_x += dx;
             }
             new_event(x,y-1);
             new_event(x-1,y-1);
             new_event(x+1,y-1);
             new_event(x+dx,y);
             new_event(x+dx+dx,y);
      }
}
//###################################################################
//# feld_begehbar(int y, int x)
//###################################################################
int feld_begehbar(int y, int x)
{
   switch (feld[y][x].inhalt)
   {
      case empty:
         return TRUE;
      case earth:
         return TRUE;
      case diamond:
         anz_collected_dias++;
         return TRUE;
      default:
         return FALSE;
   }
}

//###################################################################
//# handle_explo(int x,int y) aufgerufen durch explodiere(x,y)
//###################################################################
void handle_explo(int x,int y, int x_o, int y_o)
{
   switch(feld[y][x].inhalt)
   {
        case steel:
           break;
        case hero:
           feld[y][x].inhalt = bald_explo_nix;
           new_event(x,y);
           break;
        case red_bomb:
        case green_bomb:
        case fire_cracker:
        case bomb_cross:
           feld[y][x].inhalt = bald_explo_nix;
           new_event(x,y);
           break;
        case butter_fly:
           feld[y][x].inhalt = bald_explo_dia;
           new_event(x,y);
           break;
        case green_slime:
           anz_green_slime--;
           if (anz_green_slime <= 0) green_slime_im_level = FALSE;
           feld[y][x] = feld[y_o][x_o];
           setze_spiel_element( x<<4, y<<4, feld[y][x].aussehen);
           new_event(x,y);
           break;
        default:
           feld[y][x] = feld[y_o][x_o];
           setze_spiel_element( x<<4, y<<4, feld[y][x].aussehen);
           new_event(x,y);
           break;
   }
}

//###################################################################
//# void explodiere(x,y) ausgelst durch bald_explo
//###################################################################
void explodiere(int x,int y)
{
   int ergebnis = -1;
   BYTE aussehen = feld[y][x].aussehen;
   switch (feld[y][x].inhalt)
   {
     case bald_explo_dia:
        ergebnis = explo_dia;
        feld[y][x].inhalt = explo_dia;
        feld[y][x].aussehen = explo_dia-2;
        break;
     case bald_explo_nix:
        feld[y][x].inhalt = explo_nix;
        feld[y][x].aussehen = explo_nix-1;
        ergebnis = explo_nix;
        break;
   }

   if (ergebnis != -1)
   { // d.h. feld war bald_explo_dia, bald_explo_nix

     setze_spiel_element( x<<4, y<<4, ergebnis);
     new_event(x,y);
     if (aussehen == bomb_cross)
     {

         for (int i=0;i<5;i++)
         {
            if (x-i >= 0) {
               if (feld[y][x-i].inhalt == steel) break;
               else handle_explo(x-i,y, x,y); }
         }
         for (i=0;i<5;i++)
         {
            if (x+i < FELD_AUFL_X) {
               if (feld[y][x+i].inhalt == steel) break;
               else handle_explo(x+i,y, x,y); }
         }
         for (i=0;i<5;i++)
         {
            if (y-i >= 0) {
               if (feld[y-i][x].inhalt == steel) break;
               else handle_explo(x,y-i, x,y); }
         }
         for (i=0;i<5;i++)
         {
            if (y+i < FELD_AUFL_Y) {
               if (feld[y+i][x].inhalt == steel) break;
               else handle_explo(x,y+i, x,y); }
         }
     }
     else
     {
        handle_explo(x-1,y-1,   x,y);
        handle_explo(x+1,y-1,   x,y);
        handle_explo(x  ,y-1,   x,y);
        handle_explo(x-1,y+1,   x,y);
        handle_explo(x+1,y+1,   x,y);
        handle_explo(x  ,y+1,   x,y);
        handle_explo(x-1,y,     x,y);
        handle_explo(x+1,y,     x,y);
     }
   }
}

//###################################################################
//# void handle_hero(int x, int y)
//###################################################################
void handle_hero(int x, int y)
{
   int ch;
   ch = get_kb_command();
   if (ch && !menu_active)
   {
      if (ch & shift)
      {
         switch (ch & (up|down|left|right))
         { // hier mit SHIFT gedrckt !!!!!!!!
              case up:
                   if (anim_start_table[6] != 8)
                   { // geht bereits nach oben ?
                      anim_start_table[6] = 8;
                      anim_convert_table[6] = 8;
                      anim_end_table[6] = 12;
                   }
                   if (feld_begehbar(y-1,x))
                   {
                     feld[y-1][x].inhalt = empty;
                     feld[y-1][x].aussehen = empty;
                     setze_spiel_element( x<<4, (y-1)<<4, feld[y-1][x].aussehen);
                      // TODO new_events um leer-feld verteilen
                   }
                   break;
              case down:
                   if (anim_start_table[6] != 60)
                   { // geht bereits nach unten ?
                      anim_start_table[6] = 60;
                      anim_convert_table[6] = 60;
                      anim_end_table[6] = 64;
                   }
                   if (feld_begehbar(y+1,x))
                   {
                     feld[y+1][x].inhalt = empty;
                     feld[y+1][x].aussehen = empty;
                     setze_spiel_element( x<<4, (y+1)<<4, feld[y+1][x].aussehen);
                   }
                   break;
              case left:
                   if (anim_start_table[6] != 52)
                   { // geht bereits nach links ?
                      anim_start_table[6] = 52;
                      anim_convert_table[6] = 52;
                      anim_end_table[6] = 55;
                   }
                   if (feld_begehbar(y,x-1))
                   {
                     feld[y][x-1].inhalt = empty;
                     feld[y][x-1].aussehen = empty;
                     setze_spiel_element( x<<4, y<<4, feld[y][x].aussehen);
                     setze_spiel_element( (x-1)<<4, y<<4, feld[y][x-1].aussehen);
                   }
                   else
                   {
                      feld_schieben(y,x,-1,TRUE);
                   }
                   break;
              case right:
                   if (anim_start_table[6] != 48)
                   { // geht bereits nach rechts ?
                      anim_start_table[6] = 48;
                      anim_convert_table[6] = 48;
                      anim_end_table[6] = 51;
                   }
                   if (feld_begehbar(y,x+1))
                   {
                     feld[y][x+1].inhalt = empty;
                     feld[y][x+1].aussehen = empty;
                     setze_spiel_element( x<<4, y<<4, feld[y][x].aussehen);
                     setze_spiel_element( (x+1)<<4, y<<4, feld[y][x+1].aussehen);
                   }
                   else
                   {
                      feld_schieben(y,x,+1,TRUE);
                   }
                   break;
              default:
                   if (anim_start_table[6] != 43)
                   { // wartet bereits ?
                      anim_start_table[6] = 43;
                      anim_convert_table[6] = 43;
                      anim_end_table[6] = 47;
                   }
                   break;

         }
         new_event(x+1,y-2); // Zustzliche events fr SHIFT Bewegung :->
         new_event(x  ,y-2);
         new_event(x-1,y-2);

         new_event(x+2,y-1);
         new_event(x-2,y-1);

         new_event(x+2,y);
         new_event(x-2,y);

         new_event(x+1,y+1);
         new_event(x-1,y+1);

         new_event(x,y+2);

      }
      else // hier *OHNE* SHIFT !!!!!!!!
      {
         switch(ch & (up|down|left|right))
         {
              case up:
                   if (anim_start_table[6] != 8)
                   { // geht bereits nach oben ?
                      anim_start_table[6] = 8;
                      anim_convert_table[6] = 8;
                      anim_end_table[6] = 12;
                   }
                   if (feld_begehbar(y-1,x))
                   {
                     feld[y-1][x] = feld[y][x];
                     feld[y][x].inhalt = empty;
                     feld[y][x].aussehen = empty;
                     setze_spiel_element( x<<4, y<<4, feld[y][x].aussehen);
                     setze_spiel_element( x<<4, (y-1)<<4, feld[y-1][x].aussehen);
                     hero_y = y;
                   }
                   break;
              case down:
                   if (anim_start_table[6] != 60)
                   { // geht bereits nach unten ?
                      anim_start_table[6] = 60;
                      anim_convert_table[6] = 60;
                      anim_end_table[6] = 64;
                   }
                   if (feld_begehbar(y+1,x))
                   {
                     feld[y+1][x] = feld[y][x];
                     feld[y][x].inhalt = empty;
                     feld[y][x].aussehen = empty;
                     setze_spiel_element( x<<4, y<<4, feld[y][x].aussehen);
                     setze_spiel_element( x<<4, (y+1)<<4, feld[y+1][x].aussehen);
                     hero_y = y;
                   }
                   break;
              case left:
                   if (anim_start_table[6] != 52)
                   { // geht bereits nach links ?
                      anim_start_table[6] = 52;
                      anim_convert_table[6] = 52;
                      anim_end_table[6] = 55;
                   }
                   if (feld_begehbar(y,x-1))
                   {
                     feld[y][x-1] = feld[y][x];
                     feld[y][x].inhalt = empty;
                     feld[y][x].aussehen = empty;
                     setze_spiel_element( x<<4, y<<4, feld[y][x].aussehen);
                     setze_spiel_element( (x-1)<<4, y<<4, feld[y][x-1].aussehen);
                     hero_x = x;
                   }
                   else feld_schieben(y,x,-1, FALSE);
                   break;
              case right:
                   if (anim_start_table[6] != 48)
                   { // geht bereits nach rechts ?
                      anim_start_table[6] = 48;
                      anim_convert_table[6] = 48;
                      anim_end_table[6] = 51;
                   }
                   if (feld_begehbar(y,x+1))
                   {
                     feld[y][x+1] = feld[y][x];
                     feld[y][x].inhalt = empty;
                     feld[y][x].aussehen = empty;
                     setze_spiel_element( x<<4, y<<4, feld[y][x].aussehen);
                     setze_spiel_element( (x+1)<<4, y<<4, feld[y][x+1].aussehen);
                     hero_x = x;
                   }
                   else feld_schieben(y,x,+1,FALSE);
                   break;
              default:
                   if (anim_start_table[6] != 43)
                   { // wartet bereits ?
                      anim_start_table[6] = 43;
                      anim_convert_table[6] = 43;
                      anim_end_table[6] = 47;
                   }
                   break;

         }
      }
      new_event(x+1,y-1);
      new_event(x-1,y-1);

      new_event(x+1,y);
      new_event(x-1,y);
      new_event(x,y+1);
      new_event(x,y-1);

      new_event(hero_x+1,hero_y);
      new_event(hero_x-1,hero_y);
      new_event(hero_x,hero_y+1);
      new_event(hero_x,hero_y-1);

   }
   else
   {
      if (anim_start_table[6] != 43)
      { // wartet bereits ?
         anim_start_table[6] = 43;
         anim_convert_table[6] = 43;
         anim_end_table[6] = 47;
      }

   }
   new_event(x,y);


}

//###################################################################
//# char gefahr_fuer_kaefer(x,y)
//# berprft die Umgebung eines Schmetterlings/Feuerkfers
//# auf explosionsauslsende Spielemente wie Amben, boulder ...
// FEHLER: Anz der Amben mu noch irgendwie angepat werden...
//###################################################################
inline char gefahr_fuer_kaefer(int x,int y)
{
   if (feld[y-1][x  ].inhalt==green_slime||feld[y-1][x  ].inhalt==hero) return 1;
   if (feld[y  ][x-1].inhalt==green_slime||feld[y  ][x-1].inhalt==hero) return 1;
   if (feld[y  ][x+1].inhalt==green_slime||feld[y  ][x+1].inhalt==hero) return 1;
   if (feld[y+1][x  ].inhalt==green_slime||feld[y+1][x  ].inhalt==hero) return 1;
   return 0;
}

//###################################################################
//# void handle_events()                                            #
//###################################################################
void handle_events()
{
   static signed char butter_fly_dx[] = {0,-1,0,1};
   static signed char butter_fly_dy[] = {-1,0,1,0};
   static signed char fire_cracker_dx[] = {1,0,-1,0};
   static signed char fire_cracker_dy[] = {0,1,0,-1};


   struct event_list_entry *ptr;
   struct event_list *events_ptr;
   int dx,dy,r,x,y;

   green_slime_frei = FALSE;
   if (events != NULL)
   {
   if (events->next == NULL) // neuen kettenzeiger anfgen...
   {
      events_ptr = (event_list *) my_alloc(sizeof(event_list));
      events_ptr->next = events->next; // == NULL
      events_ptr->entry = NULL;
      events->next = events_ptr;
   }

   ptr = events->entry;

   while (ptr)
   {
     x = ptr->pos.x;
     y = ptr->pos.y;
     switch (feld[y][x].inhalt)
     {
        //#####################
        case hero:
             handle_hero(x,y); // nur damit Platz frei wird...
             break;
        //#####################
        case in:
             if (feld[y][x].counter > 0)
             {
                feld[y][x].counter--;
                feld[y][x].aussehen = (feld[y][x].counter & 2)
                                      ? steel : in_frame;
             }
             else
             {
                feld[y][x].aussehen = hero;
                feld[y][x].inhalt = hero;
             }
             new_event(x,y);
             break;

        //#####################
        case bald_explo_nix:
        case bald_explo_dia:
             explodiere(x,y);
             break;
        //#####################
        case y_grow:
             {
                if (feld[y+1][x].inhalt == empty)
                {
                   feld[y+1][x] = feld[y][x];
                   setze_spiel_element( x<<4, (y+1)<<4, feld[y+1][x].aussehen);
                   new_event (x,y+1);
                }
                if (feld[y-1][x].inhalt == empty)
                {
                   feld[y-1][x] = feld[y][x];
                   setze_spiel_element( x<<4, (y-1)<<4, feld[y-1][x].aussehen);
                   new_event (x,y-1);
                }
             }
             break;

        //#####################
        case green_slime:
             r = rand() % 4;
             dx = butter_fly_dx[ r ];
             dy = butter_fly_dy[ r ];
             if (feld[y+dy][x+dx].inhalt == empty
               ||feld[y+dy][x+dx].inhalt == earth)
             {
                feld[y+dy][x+dx] = feld[y][x];
                setze_spiel_element( (x+dx)<<4, (y+dy)<<4, feld[y+dy][x+dx].aussehen);
                anz_green_slime++;
                new_event(x+dx,y+dy);
                new_event(x,y);
                if (anz_green_slime >= max_anz_green_slime)
                {
                   if ( feld[y][x+1].inhalt == empty
                     || feld[y][x-1].inhalt == empty
                     || feld[y-1][x].inhalt == empty
                     || feld[y+1][x].inhalt == empty
                     || feld[y][x+1].inhalt == earth
                     || feld[y][x-1].inhalt == earth
                     || feld[y-1][x].inhalt == earth
                     || feld[y+1][x].inhalt == earth)
                      green_slime_frei = TRUE;
                   if ( feld[y][x+dx+1].inhalt == empty
                     || feld[y][x-dx-1].inhalt == empty
                     || feld[y-dy-1][x].inhalt == empty
                     || feld[y+dy+1][x].inhalt == empty
                     || feld[y][x+dx+1].inhalt == earth
                     || feld[y][x-dx-1].inhalt == earth
                     || feld[y-dy-1][x].inhalt == earth
                     || feld[y+dy+1][x].inhalt == earth)
                      green_slime_frei = TRUE;
                   green_slime_morph();
                }
             }
             if ( feld[y][x+1].inhalt == empty
               || feld[y][x-1].inhalt == empty
               || feld[y-1][x].inhalt == empty
               || feld[y+1][x].inhalt == empty
               || feld[y][x+1].inhalt == earth
               || feld[y][x-1].inhalt == earth
               || feld[y-1][x].inhalt == earth
               || feld[y+1][x].inhalt == earth)
             {
                new_event(x,y);
                green_slime_frei = TRUE;
             }
             break;
        //#####################
        case butter_fly:
             if (gefahr_fuer_kaefer(x,y))
             {
                feld[y][x].inhalt = bald_explo_dia;
                new_event(x,y);
                break;
             }

             r = feld[y][x].richtung;
             dx = butter_fly_dx[ r ];
             dy = butter_fly_dy[ r ];

             if (feld[y+dy][x+dx].inhalt == empty)
             {
                feld[y+dy][x+dx] = feld[y][x];
                new_event(x,y+1);
                new_event(x,y-1);
                new_event(x+1,y);
                new_event(x-1,y);
                new_event(x+1,y-1);
                new_event(x-1,y-1);
                feld[y][x].inhalt = empty;
                feld[y][x].aussehen = empty;
                setze_spiel_element( (x+dx)<<4, (y+dy)<<4, feld[y+dy][x+dx].aussehen);
                setze_spiel_element( x<<4, y<<4, empty);
                r +=3;
                r %= 4;
                dx += butter_fly_dx[ r ];
                dy += butter_fly_dy[ r ];
                if (feld[y+dy][x+dx].inhalt == empty)
                {
                   dx -= butter_fly_dx[ r ];
                   dy -= butter_fly_dy[ r ];
                   feld[y+dy][x+dx].richtung = r;
                }
             }
             else
             {
                 if ( feld[y][x+1].inhalt == empty
                   || feld[y][x-1].inhalt == empty
                   || feld[y-1][x].inhalt == empty
                   || feld[y+1][x].inhalt == empty)
                  {
                     r++;
                     feld[y][x].richtung = r % 4;
                     new_event(x,y);
                  }
             }
             break;

        //#####################
        case fire_cracker:
             if (gefahr_fuer_kaefer(x,y))
             {
                feld[y][x].inhalt = bald_explo_nix;
                new_event(x,y);
                break;
             }

             r = feld[y][x].richtung;
             dx = fire_cracker_dx[ r ];
             dy = fire_cracker_dy[ r ];

             if (feld[y+dy][x+dx].inhalt == empty)
             {
                feld[y+dy][x+dx] = feld[y][x];
                new_event(x,y+1);
                new_event(x,y-1);
                new_event(x+1,y);
                new_event(x-1,y);
                new_event(x+1,y-1);
                new_event(x-1,y-1);
                feld[y][x].inhalt = empty;
                feld[y][x].aussehen = empty;
                setze_spiel_element( (x+dx)<<4, (y+dy)<<4, feld[y+dy][x+dx].aussehen);
                setze_spiel_element( x<<4, y<<4, empty);
                r +=3;
                r %= 4;
                dx += fire_cracker_dx[ r ];
                dy += fire_cracker_dy[ r ];
                if (feld[y+dy][x+dx].inhalt == empty)
                {
                   dx -= fire_cracker_dx[ r ];
                   dy -= fire_cracker_dy[ r ];
                   feld[y+dy][x+dx].richtung = r;
                }
             }
             else
             {
                 if ( feld[y][x+1].inhalt == empty
                   || feld[y][x-1].inhalt == empty
                   || feld[y-1][x].inhalt == empty
                   || feld[y+1][x].inhalt == empty)
                  {
                     r++;
                     feld[y][x].richtung = r % 4;
                     new_event(x,y);
                  }
             }
             break;
        //#####################
        case x_grow:
             {
                if (feld[y][x+1].inhalt == empty)
                {
                   feld[y][x+1] = feld[y][x];
                   setze_spiel_element( (x+1)<<4, y<<4, feld[y][x+1].aussehen);
                   new_event (x+1,y);
                }
                if (feld[y][x-1].inhalt == empty)
                {
                   feld[y][x-1] = feld[y][x];
                   setze_spiel_element( (x-1)<<4, y<<4, feld[y][x-1].aussehen);
                   new_event (x-1,y);
                }
             }
             break;
        //#####################
        case diamond:
        case stone:
             switch (feld[y+1][x].inhalt)
             {
                case empty:
                    feld[y+1][x] = feld[y][x];
                    feld[y][x].inhalt = empty;
                    feld[y][x].aussehen = empty;
                    setze_spiel_element( x<<4, y<<4, empty);
                    setze_spiel_element( x<<4, (y+1)<<4, feld[y+1][x].aussehen);
                    etwas_fiel(x,y+1);
                    new_event (x,y-1); // falls oben stein etc. liegt
                    new_event (x+1,y);
                    new_event (x-1,y);
                    new_event (x+1,y-1);
                    new_event (x-1,y-1);
                    new_event (x,y+1);
                    break;
                case stone:
                case diamond:
                case wall:
                    if (feld[y][x+1].inhalt == empty
                     && feld[y+1][x+1].inhalt == empty)
                    {
                       feld[y][x+1] = feld[y][x];
                       setze_spiel_element( (x+1)<<4, y<<4, feld[y][x+1].aussehen);
                       feld[y][x].inhalt = empty;
                       feld[y][x].aussehen = empty;
                       setze_spiel_element( x<<4, y<<4, empty);
                       new_event (x,y-1); // falls oben stein etc. liegt
                       new_event (x+1,y-1);
                       new_event (x-1,y-1);
                       new_event (x+1,y);

                    }
                    if (feld[y][x-1].inhalt == empty
                     && feld[y+1][x-1].inhalt == empty)
                    {
                       feld[y][x-1] = feld[y][x];
                       setze_spiel_element( (x-1)<<4, y<<4, feld[y][x-1].aussehen);
                       feld[y][x].inhalt = empty;
                       feld[y][x].aussehen = empty;
                       setze_spiel_element( x<<4, y<<4, empty);
                       new_event (x,y-1); // falls oben stein etc. liegt
                       new_event (x+1,y-1);
                       new_event (x-1,y-1);
                       new_event (x-1,y);
                    }
                    break;

             }
             break;
        //#####################
        case explo_dia:
             feld[y][x].aussehen++;
             if (feld[y][x].aussehen - feld[y][x].inhalt == 3)
             {
                feld[y][x].aussehen += 8;
             }
             else if (feld[y][x].aussehen - feld[y][x].inhalt >= 17)
             {
                feld[y][x].inhalt = diamond;
                feld[y][x].aussehen = diamond;
             }
             new_event(x,y);
             setze_spiel_element( x<<4, y<<4, feld[y][x].aussehen);
             break;

        //#####################
        case explo_nix:
             feld[y][x].aussehen++;
             if (feld[y][x].aussehen - feld[y][x].inhalt >= 11)
             {
                feld[y][x].inhalt = empty;
                feld[y][x].aussehen = empty;
                new_event(x+1,y); // neu falls dia nach benachbarter explo frei fallen kann
                new_event(x-1,y);
                new_event(x,y-1);
                new_event(x,y+1);
             }
             else
                new_event(x,y);
             setze_spiel_element( x<<4, y<<4, feld[y][x].aussehen);
             break;
        //#####################
        case bomb_cross:
        case red_bomb:
        case green_bomb:
             switch (feld[y+1][x].inhalt)
             {
                case empty:
                    feld[y+1][x] = feld[y][x];
                    feld[y][x].inhalt = empty;
                    feld[y][x].aussehen = empty;
                    setze_spiel_element( x<<4, y<<4, empty);
                    setze_spiel_element( x<<4, (y+1)<<4, feld[y+1][x].aussehen);
                    etwas_fiel(x,y+1);
                    new_event (x,y-1); // falls oben stein etc. liegt
                    new_event (x+1,y);
                    new_event (x-1,y);
                    new_event (x+1,y-1);
                    new_event (x-1,y-1);
                    new_event (x,y+1);
                    break;
                case stone:
                case bomb_cross:
                case red_bomb:
                case green_bomb:
                case diamond:
                case wall:
                    if (feld[y][x+1].inhalt == empty
                     && feld[y+1][x+1].inhalt == empty)
                    {
                       feld[y][x+1] = feld[y][x];
                       setze_spiel_element( (x+1)<<4, y<<4, feld[y][x+1].aussehen);
                       feld[y][x].inhalt = empty;
                       feld[y][x].aussehen = empty;
                       setze_spiel_element( x<<4, y<<4, empty);
                       new_event (x,y-1); // falls oben stein etc. liegt
                       new_event (x+1,y-1);
                       new_event (x-1,y-1);
                       new_event (x+1,y);

                    }
                    if (feld[y][x-1].inhalt == empty
                     && feld[y+1][x-1].inhalt == empty)
                    {
                       feld[y][x-1] = feld[y][x];
                       setze_spiel_element( (x-1)<<4, y<<4, feld[y][x-1].aussehen);
                       feld[y][x].inhalt = empty;
                       feld[y][x].aussehen = empty;
                       setze_spiel_element( x<<4, y<<4, empty);
                       new_event (x,y-1); // falls oben stein etc. liegt
                       new_event (x+1,y-1);
                       new_event (x-1,y-1);
                       new_event (x-1,y);
                    }
                    break;

             }
             break;

     }
     ptr = ptr->next;
   }
   if (green_slime_im_level && !green_slime_frei) green_slime_morph();
   // nun ist aktuelle event kette abgearbeitet und mu freigegeben werden

   while (events->entry) // gibt es noch eine kette?
   {
     ptr = events->entry;       // zeiger auf oberstes element
     events->entry = ptr->next; // oberstes element ausklinken
     free(ptr);                 // oberstes element lschen
   }
   events_ptr = events;    // zeiger auf erste 'kette'
   events = events->next;  // erste 'kette' ausklinken
   free (events_ptr);      // erste 'kette' lschen
   }
}

//###################################################################
//# void green_slime_morph()
//###################################################################
void green_slime_morph()
{
   int x,y;
   int ergebnis;
   ergebnis = (green_slime_frei) ? stone : diamond;
   for (x=0;x<FELD_AUFL_X;x++)
      for (y=0;y<FELD_AUFL_Y;y++)
         if (feld[y][x].inhalt == green_slime)
         {
            feld[y][x].inhalt = ergebnis;
            feld[y][x].aussehen = ergebnis;
            setze_spiel_element( x<<4, y<<4, ergebnis);
            new_event(x,y);
         }
   green_slime_im_level = FALSE;
}
