#include <conio.h>
#include <graph.h>

#include "boulder.h"

//###################################################################
// Globals

unsigned char active_screen=0;
unsigned char deltax_alt=0;
unsigned char deltay_alt=0;

WORD draw_screenx=21, draw_screeny=14;

// ###################################################################
// Konstanten fr speedup.asm

unsigned long asm_sprite_start_vram = 0x0a0000 + START_SPRITES;
unsigned short asm_xaufl_feld = FELD_AUFL_X;
unsigned long asm_step_feld = sizeof(struct feld_element);

//###################################################################
// Deklarationen der Funktionen von speedup.asm

extern "C" void do_screen_copy_mode_x_1(
                               unsigned char* block_pointer,
                               unsigned char* feldstartpos);
extern "C" void do_screen_copy_mode_x_2(
                               unsigned char* block_pointer,
                               unsigned char* feldstartpos);
extern "C" void do_screen_copy_mode_x_3(
                               unsigned char* block_pointer,
                               unsigned char* feldstartpos);
extern "C" void setze_sprite_asm(unsigned char* quelle,
                                 unsigned char* ziel,
                                 unsigned long xaufl,
                                 unsigned long yaufl,
                                 unsigned char startplane,
                                 unsigned char trans_farbe);

#pragma aux (__cdecl) do_screen_copy_mode_x_1;
#pragma aux (__cdecl) do_screen_copy_mode_x_2;
#pragma aux (__cdecl) do_screen_copy_mode_x_3;
#pragma aux (__cdecl) setze_sprite_asm;

//###################################################################
//# void setze_mode_x()                                             #
//###################################################################

void setze_mode_x()
{
        long int i;
        unsigned short int* pointer;

        _setvideomode(_MRES256COLOR);

        outp(GC_INDEX,GC_GRAPH_MODE);
        outp(GC_INDEX+1,(inp(GC_INDEX+1) & B(11101111) ));
        outp(GC_INDEX,GC_MISCELL);
        outp(GC_INDEX+1,(inp(GC_INDEX+1) & B(11111101) ));

        outp(SC_INDEX,SC_MEM_MODE);
        outp(SC_INDEX+1,(inp(SC_INDEX+1) & B(11110111)) | 4);

        pointer = (unsigned short int*) 0xa0000;

        for (i=0;i<0x8000;i++)
          *pointer++ = 0;

        outp(CRTC_INDEX, CC_UNDERLINE);
        outp(CRTC_INDEX+1, inp(CRTC_INDEX+1) & B(10111111));

        outp(CRTC_INDEX, CC_MODE_CTRL);
        outp(CRTC_INDEX+1, inp(CRTC_INDEX+1) | B( 1000000));

        outp(CRTC_INDEX, CC_ROW_OFFSET); // auf Zeilenbreite 320+16 setzen
        outp(CRTC_INDEX+1, (320+16) / 8);

        outpw(SC_INDEX, SC_MAP_MASK + (0x0f << 8)); // Write auf alle Planes

       // outp(AC_INDEX, AC_MODE_CTRL);
       // outp(AC_INDEX+1, inp(AC_INDEX+1) | 32);
}


//###################################################################
void kopiere_sprites(unsigned char* zeiger, unsigned long anzahl_bytes,
                     unsigned short int ofs)
{
   unsigned short i;
   char plane;
   unsigned char* pix_pointer;
   unsigned char* src_pointer;
   long int real_anzahl = anzahl_bytes >> 2;

   for (plane = 0; plane < 4; plane++)
   {
      outp(SC_INDEX, SC_MAP_MASK);
      outp(SC_INDEX+1, 1 << plane);

      pix_pointer = (unsigned char*) 0xa0000 + ofs;
      src_pointer = zeiger+plane;

      for (i = 0; i < real_anzahl;i++)
      {
         *pix_pointer = *src_pointer;
         pix_pointer++; src_pointer += 4;
      }
   }
   outp(SC_INDEX, SC_MAP_MASK); /* Schn wieder Zugriff auf alle 4 Planes
                                   enablen, gelle? */
   outp(SC_INDEX+1, 0xf);
}
//###################################################################
void paint_block(unsigned char index,
                 unsigned short xpos, unsigned short ypos)
{
   unsigned char* pix_pointer;
   unsigned char* sprite_pointer;
   unsigned char a,i,save_mode;

   /* Es wird davon ausgegangen, da der Zugriff auf alle vier Planes
      enabled ist! */

   if (active_screen == 0)
      pix_pointer = (unsigned char*) (0x0a0000 + START_BILD_1);
   else
      pix_pointer = (unsigned char*) (0x0a0000 + START_BILD_2);

   outp(GC_INDEX, GC_GRAPH_MODE);
   save_mode = inp(GC_INDEX+1);
   outp(GC_INDEX+1, (save_mode & (255-3)) | 1);

   sprite_pointer= (unsigned char*) (0x0a0000 + START_SPRITES + (index << 6));
   pix_pointer += (84 * ypos + (xpos >> 2));

   for (a = 0; a < 16; a++)
   {
       for (i = 0; i < 4; i++)
           *pix_pointer++ = *sprite_pointer++;

       pix_pointer += (320-16+16) / 4;
   }

   outp(GC_INDEX, GC_GRAPH_MODE);
   outp(GC_INDEX+1, save_mode);
}

//###################################################################
void paint_feld_mode_x_1(unsigned char startx, unsigned char starty, int line_starty)
{
    unsigned char* block_pointer;
  //  unsigned char* sprite_pointer;
  //  unsigned char* pix_pointer;
  //  unsigned char a,i,x,y,x_end,y_end;
    unsigned char save_mode;

    if (active_screen == 0)
       block_pointer = (unsigned char *) (0x0a0000 + START_BILD_1);
    else
       block_pointer = (unsigned char *) (0x0a0000 + START_BILD_2);

    outp(GC_INDEX, GC_GRAPH_MODE);
    save_mode= inp(GC_INDEX+1);
    outp(GC_INDEX+1,(save_mode & (255-3)) | 1);

    set_debug_farbe(4);

    block_pointer += line_starty * 84;

    do_screen_copy_mode_x_1(block_pointer,
                   &feld[starty][startx].aussehen
                   );

    set_debug_farbe(0);

    outp(GC_INDEX, GC_GRAPH_MODE);
    outp(GC_INDEX+1,save_mode);

}

//###################################################################

void paint_feld_mode_x_2(unsigned char startx, unsigned char starty, int line_starty)
{
    unsigned char* block_pointer;

    if (active_screen == 0)
       block_pointer = (unsigned char *) (0x0a0000 + START_BILD_1);
    else
       block_pointer = (unsigned char *) (0x0a0000 + START_BILD_2);

    block_pointer += (line_starty * 84);

    set_debug_farbe(4);

    do_screen_copy_mode_x_2(block_pointer,
                            &feld[starty][startx].aussehen);

    set_debug_farbe(0);
}

//###################################################################

void paint_feld_mode_x_3(unsigned char startx, unsigned char starty, int line_starty)
{
    unsigned char* block_pointer;

    if (active_screen == 0)
       block_pointer = (unsigned char *) (0x0a0000 + START_BILD_1);
    else
       block_pointer = (unsigned char *) (0x0a0000 + START_BILD_2);

    block_pointer += line_starty * 84;

    set_debug_farbe(4);

    do_screen_copy_mode_x_3(block_pointer,
                            &feld[starty][startx].aussehen);

    set_debug_farbe(0);
}

//###################################################################
//# void setze_spiel_element(short xpos, short ypos,long index)
//###################################################################
void setze_spiel_element(short xpos, short ypos,long index)
{
   // int x,y;
   // if (inp(0x60) == 1)
   // {
   //   _setvideomode(_DEFAULTMODE);
   //   exit(1);
   // }
   if (graphik_modus == MODE_X_256_COLORS)
   {
     // if ((xpos >= feldx && xpos <= feldx+screenx+1) &&
     //     (ypos >= feldy && ypos <= feldy+screeny+1))
     // {
     //  paint_block(index,xpos,ypos);
     // }
   }
   else _putimage(xpos,ypos, (char*) feld_grafik[ index ], _GPSET);

}


//###################################################################

void paint_feld(int graphik_modus, int starty, int feldx, int feldy, int xaufl, int yaufl)
{
   int x,y;

   draw_screenx = xaufl;
   draw_screeny = yaufl;

   switch (graphik_modus)
   {
      case MODE_X_256_COLORS:
         paint_feld_mode_x_2(feldx,feldy, starty);
         break;
      default:
         for (x=0;x<FELD_AUFL_X;x++)
             for (y=0;y<FELD_AUFL_Y;y++)
             {
                 setze_spiel_element( x<<4, y<<4+starty, feld[y][x].aussehen);
             }
         break;
   }
}

//###################################################################
void setze_sprite(unsigned char* spritezeiger, unsigned int xaufl,
                                               unsigned int yaufl,
                                               unsigned int xpos,
                                               unsigned int ypos)
{
    unsigned char* pix_start_pointer;
  //  unsigned char* pix_pointer;
  //  unsigned char* pix_spritezeiger;
    unsigned int screen_ofs;
  //  unsigned char i,b;
    unsigned char plane;
  //  unsigned int x,y;
    unsigned int xaufl1 = xaufl >> 2;

    xpos += deltax_alt;
    ypos += deltay_alt;

    screen_ofs = ypos * 84 + (xpos >> 2);

    if (active_screen == 0)
       pix_start_pointer = (unsigned char*)
           (0x0a0000 + START_BILD_1+screen_ofs);
    else
       pix_start_pointer = (unsigned char*)
           (0x0a0000 + START_BILD_2+screen_ofs);

    plane = xpos & 3;

    set_debug_farbe(3);

    setze_sprite_asm(spritezeiger, pix_start_pointer, xaufl1, yaufl, plane,
                     TRANS_FARBE);

    set_debug_farbe(0);

    outpw(SC_INDEX, SC_MAP_MASK + (0x0f << 8)); // Write auf alle Planes
}

//###################################################################
void set_other_page(unsigned char deltax, unsigned char deltay)
{
   int start1,start2,deltax1; // ,i;
   long add_ofs;

   if (active_screen == 0)
      add_ofs = START_BILD_1;
   else
      add_ofs = START_BILD_2;

   add_ofs += deltay_alt * (320+16) / 4;
   add_ofs += deltax_alt >> 2;

   deltax1 = ((deltax_alt & B(11)) << 1) | 32;
   start1 = CC_START_LO + ((add_ofs & 0xff) << 8);
   start2 = CC_START_HI + (add_ofs & 0xff00);

   outpw(CRTC_INDEX,start1);
   outpw(CRTC_INDEX,start2);

   set_debug_farbe(2);

   wait_retrace();
   outp(AC_INDEX, AC_HOR_PP);
   outp(AC_INDEX, deltax1);

   set_debug_farbe(0);

   active_screen = 1 - active_screen;

   deltax_alt = deltax;
   deltay_alt = deltay;

}

//###################################################################
void setze_palette(unsigned char* zeiger)
{
    short int i;
    wait_retrace();
    outp(DAC_WRITE_ADR,0);

    for (i=0;i<768;i++)
       outp(DAC_DATA, zeiger[i]);

}

//###################################################################
//void blend_ab(unsigned char* zeiger)
//{


//}
//###################################################################
//void blend_auf(unsigned char* zeiger)
//{

//}

//###################################################################
//###################################################################



/*
#pragma aux setze_palette= \
"mov dx,0x3c8"   \
"mov al,0"       \
"out dx,al"      \
"inc dx"         \
"mov cx,768"     \
"rep outsb"      \
parm[si]         \
modify[ax dx cx si];
*/
