// Leveledit fr Boulder
#include <stdio.h>
#include <stdlib.h>
#include <malloc.h>
#include <graph.h>
#include <string.h>
#include <i86.h>

#include "boulder.h"

int anzeigen_pos = 0;           // oben die linke seite der kleinteile
int set_element = 0;            // Spielfeldelement, da mit linker Mtaste
                                // gesetzt wird (zeiger in Tab spiel_elemente)
int edit_x, edit_y;             // pos des Spielfelds
unsigned char status[320*8];    // Status zeile
char ach_status[40], ach_status_a[40];
const int maus_speed = 5;
int ch;                         // Eingabewert bei LevEd wird auch von handlemaus
                                // verwendet

int spiel_elemente[] =
{
  victim, wall, empty, red_bomb,
  green_bomb,
  green_bomb+1, green_bomb+2, green_bomb+3,
  green_bomb+4, green_bomb+5, green_bomb+6,
  green_bomb+7, green_bomb+8, green_bomb+9,
  green_bomb+10,
  stone, earth, steel,

  x_grow, y_grow,
  diamond, blue_slime, green_slime,
  in, out, out_hidden,

  fire_cracker, butter_fly,
  milling_wall, hero, bomb_cross
  };


//###################################################################
//# void male_anzeige()
//###################################################################
void male_anzeige()
{
   int x = 16;
   int nr;

   setze_sprite(status,320,8,0,16);

   setze_sprite(&grafik[menu_left<<8], 16,16,0,0);
   setze_sprite(&grafik[menu_right<<8], 16,16,304,0);

   for (int i = 0; i < 18; i++, x+=16)
   {
      nr = spiel_elemente[anzeigen_pos+i];
      if (nr < 7) nr = anim_convert_table[nr];
      setze_sprite(&grafik[nr<<8], 16,16,x,0);
   }
   nr = set_element - anzeigen_pos;
   if (nr >= 0 && nr < 18)
   {
      // Rahmen fr ausgewhltes Spielelement ausgeben...
      setze_sprite(&grafik[frame<<8],16,16,16*nr+16,0);
   }
}

//###################################################################
//# void chg_status( char * s)
//###################################################################
void chg_status( char * s)
{
   memset (status,0,320*8);
   int nr;
   for (int i = 0;i < 40;i++)
   {
       if (s[i] == 0) break;
       nr = ascii_zs[s[i]];
       for (int x=0;x<8;x++)
          for (int y=0;y<8;y++)
          {
             if (schrift[nr*256 + 2*y*16 + 2*x ])
                 status[y*320 + 8 * i + x] = y + 24;
          }
   }
}

//###################################################################
//# void handle_maus()
//###################################################################
void handle_maus()
{
  // union REGS r;
  // struct SREGS s;
  // s.ds = s.es = s.fs = s.gs = FP_SEG( &s );
   static int maus_scroll_counter = maus_speed;
   int x,y;
   int mouse_xpos, mouse_ypos;
   int mouse_buttons;

   // Maus Pos holen
   // r.w.ax = 0x3;
   // int386x (0x33, &r, &r, &s);
   get_mouse_position(mouse_xpos, mouse_ypos);
   mouse_buttons = get_mouse_buttons();

   // Rechteck unten malen
   if (mouse_ypos > 24)
   {
      x = mouse_xpos / 16;
      y = (mouse_ypos - 24) / 16;
      setze_sprite( &grafik[ frame << 8 ], 16,16, x*16 , y*16+24 );
      sprintf(ach_status,"%d:%d",edit_x+x,edit_y+y);
      if ( strncmp(ach_status,ach_status_a,40) )
      {
         strncpy(ach_status_a, ach_status, 39);
         chg_status(ach_status);
      }
   }
   // Mauszeiger malen
   setze_sprite( &grafik[ mouse << 8 ], 16,16, mouse_xpos , mouse_ypos );

   // Auf Klicken der linken Maustaste reagieren...
   if (mouse_buttons & 1)
   {
      if (mouse_ypos > 24)
      { // neues Feldelement setzen
          x = mouse_xpos / 16;
          y = (mouse_ypos - 24) / 16;
          feld[edit_y+y][edit_x+x].inhalt =   spiel_elemente[set_element];
          feld[edit_y+y][edit_x+x].aussehen = spiel_elemente[set_element];

          if (spiel_elemente[set_element] > green_bomb
              && spiel_elemente[set_element] <= green_bomb+10)
          { // Aussehen: Zhlerbombe, Verhalten: Grne Bombe
             feld[edit_y+y][edit_x+x].inhalt = green_bomb;
          }
      }
      else if (mouse_ypos < 16)
      { // neues Feldelement auswhlen (oder scrollen links-rechts)
         x = mouse_xpos / 16;
         if (x == 0)
         {
            anzeigen_pos = (anzeigen_pos > 0) ? anzeigen_pos-1:0;
         }
         else if (x == 19)
         {
            anzeigen_pos = (anzeigen_pos < sizeof(spiel_elemente)/sizeof(int)-18)
                           ? anzeigen_pos+1:anzeigen_pos;
         }
         else
         {
            set_element = x + anzeigen_pos - 1;
         }
      }
   }
   // An Kanten des Bildschirm scrollen
   if (mouse_xpos == 0 && mouse_ypos > 24) if (!maus_scroll_counter--)
   { ch |= left; maus_scroll_counter = maus_speed; }
   if (mouse_xpos == 318 && mouse_ypos > 24) if (!maus_scroll_counter--)
   { ch |= right; maus_scroll_counter = maus_speed; }
   if (mouse_ypos == 0) if (!maus_scroll_counter--)
   { ch |= up; maus_scroll_counter = maus_speed; }
   if (mouse_ypos == 198) if (!maus_scroll_counter--)
   { ch |= down; maus_scroll_counter = maus_speed; }
}


//###################################################################
//# void exit_level_edit()
//# rumt hinter dem Lveldesigner auf...
//# schliet zum Beispiel den uersten Rand mit steel zu
//###################################################################
void exit_level_edit()
{
    int x,y;
    for (x=0;x<FELD_AUFL_X;x++)
    {
       if( feld[0][x].inhalt != out && feld[0][x].inhalt != out_hidden )
       {
          feld[0][x].inhalt = steel;
          feld[0][x].aussehen = steel;
       }
       if( feld[FELD_AUFL_Y-1][x].inhalt != out
        && feld[FELD_AUFL_Y-1][x].inhalt != out_hidden )
       {
          feld[FELD_AUFL_Y-1][x].inhalt = steel;
          feld[FELD_AUFL_Y-1][x].aussehen = steel;
       }
    }
    for (y=0;y<FELD_AUFL_Y;y++)
    {
       if( feld[y][0].inhalt != out && feld[y][0].inhalt != out_hidden )
       {
          feld[y][0].inhalt = steel;
          feld[y][0].aussehen = steel;
       }
       if( feld[y][FELD_AUFL_X-1].inhalt != out
        && feld[y][FELD_AUFL_X-1].inhalt != out_hidden )
       {
          feld[y][FELD_AUFL_X-1].inhalt = steel;
          feld[y][FELD_AUFL_X-1].aussehen = steel;
       }
    }
    init_events();


}



//###################################################################
//# void level_edit()
//###################################################################
void level_edit()
{
    memset (status,0,320*8);

    chg_status("Ready!");

    anzeigen_pos = 0;
    edit_x = 0;
    edit_y = 0;



    set_other_page(0,0);
    male_anzeige();
    paint_feld(graphik_modus, 24, edit_x, edit_y, 20, 11);
    set_other_page(0,0);


    /*
    // Bereich in x-Richtung setzen
    r.w.ax = 0x7;
    r.w.cx=0;
    r.w.dx=318;
    int386x (0x33, &r, &r, &s);
    // Bereich in y-Richtung setzen
    r.w.ax = 0x8;
    r.w.cx=0;
    r.w.dx=198;
    int386x (0x33, &r, &r, &s);

    // Maus in die Mitte (?) setzen
    r.w.ax = 0x4;
    r.w.cx=160;
    //r.w.dx=100;
    r.w.dx=20;
    int386x (0x33, &r, &r, &s);
    */
    set_mouse_region(0,0,318,198);
    set_mouse_position(160,20);


    ch = 0;
    while ( !(ch & esc) )
    {
       animate_tables();
       male_anzeige();
       paint_feld(graphik_modus, 24, edit_x, edit_y, 20, 11);

       ch = get_kb_command();
       handle_maus();

       set_other_page(0,0);

       if (ch & left)
       {
          edit_x = (edit_x > 0) ? edit_x - 1: 0;
       }
       if (ch & right)
       {
          edit_x = (edit_x < FELD_AUFL_X-20) ? edit_x + 1: edit_x;
       }
       if (ch & up)
       {
          edit_y = (edit_y > 0) ? edit_y - 1: 0;
       }
       if (ch & down)
       {
          edit_y = (edit_y < FELD_AUFL_Y-11) ? edit_y + 1: edit_y;
       }

    }
    exit_level_edit();

}
