#include "boulder.h"
#include <i86.h>

enum { end_menu, action_subroutine, action_submenu, action_nop, action_bar };

struct menuitem {
        char* text;
        char action;
        void* action_pointer;
                };

extern struct menuitem option_menu[];
extern struct menuitem sound_options_menu[];
extern struct menuitem game_options_menu[];
extern struct menuitem video_options_menu[];
extern struct menuitem quit_game_menu[];

struct menuitem hauptmenu[] = {
        {"New Game", action_nop, NULL},
        {"Load Game", action_nop, NULL},
        {"Save Game", action_nop, NULL},
        {"Edit Level", action_subroutine, &level_edit},
        {"Options", action_submenu, &option_menu},
        {"Quit Game", action_submenu, &quit_game_menu},
        {"", end_menu, NULL} };

struct menuitem quit_game_menu[] = {
        {"Are you sure?", action_bar, NULL},
        {" Yeah", action_subroutine, &quit_game},
        {" Nope", action_submenu, &hauptmenu},
        {"", end_menu, NULL} };

struct menuitem option_menu[] = {
        {"Game Options", action_submenu, &game_options_menu},
        {"Video Options", action_submenu, &video_options_menu},
        {"Sound Options", action_submenu, &sound_options_menu},
        {"", action_bar, NULL},
        {"Back", action_submenu, &hauptmenu},
        {"", end_menu, NULL}};

struct menuitem game_options_menu[] = {
        {"Back", action_submenu, &option_menu},
        {"", end_menu, NULL}};

struct menuitem video_options_menu[] = {
        {"Back", action_submenu, &option_menu},
        {"", end_menu, NULL}};

struct menuitem sound_options_menu[] = {
        {"Back", action_submenu, &option_menu},
        {"", end_menu, NULL}};

char menu_active = FALSE;
short key_pressed = 0;
struct menuitem* ak_menu_pointer;
int ak_menu_item;

void handle_menu_events()
{
        //union REGS r;
        //struct SREGS s;
        //s.ds = s.es = s.fs = s.gs = FP_SEG( &s );
        int mouse_xpos;
        int mouse_ypos;
        int mouse_buttons;


        short ch = get_kb_command();

        // MOUSE zeugs added by chrisi
       // r.w.ax = 0x3;
      //  int386x (0x33, &r, &r, &s);
        mouse_buttons = get_mouse_buttons();
        if (mouse_buttons & 2)
        {
           // right mouse button
           ch |= esc;

            // Maus in die Mitte setzen
           //r.w.ax = 0x4;
           //r.w.cx=160;
           //r.w.dx=100;
           //int386x (0x33, &r, &r, &s);

           set_mouse_position(160,100);
        }
        if (menu_active)
        {
           // r.w.ax = 0x3;
           // int386x (0x33, &r, &r, &s);

            get_mouse_position(mouse_xpos, mouse_ypos);

            if (mouse_buttons & 1) ch |= enter;

            if (mouse_ypos < 100-10 || mouse_ypos > 100+10)
            {
               if (mouse_ypos < 100-10)
               {
                  ch |= up;
               }
               else
               {
                  ch |= down;
               }
               // Maus in die Mitte setzen
               set_mouse_position(160,100);
              // r.w.ax = 0x4;
              // r.w.cx=160;
              // r.w.dx=100;
              // int386x (0x33, &r, &r, &s);
            }
        }


        if (menu_active == TRUE)
           {
              int y_counter = 0;

              for (struct menuitem* p = ak_menu_pointer; p->action != end_menu; p++)
              {
                 set_flames_str(p->text, 50, y_counter*20 + 40);
                 if (y_counter == ak_menu_item)
                 {
                    set_flames_str("&", 50-16, y_counter*20 + 40);
                 }
                 y_counter++;
              }
           }

        if (key_pressed != ch)
        {
           key_pressed = ch;

           if (ch == esc)
           {
              menu_active = 1 - menu_active;
              ak_menu_pointer = hauptmenu;
              ak_menu_item = 0;
           }

           if (menu_active == TRUE)
           {
              if (ch == right || ch == left || ch == shift || ch == enter)
              {
                 switch (ak_menu_pointer[ak_menu_item].action)
                 {
                     case action_subroutine:
                        ((void*()) ak_menu_pointer[ak_menu_item].action_pointer)();
                        break;
                     case action_submenu:
                        ak_menu_pointer = (struct menuitem*)
                                   ak_menu_pointer[ak_menu_item].action_pointer;
                        ak_menu_item = 0;

                        while (ak_menu_pointer[ak_menu_item].action == action_bar)
                           ak_menu_item++;

                        break;
                     case action_nop:
                     default:
                        break;

                 }
              }
              else if (ch == down)
              {
                 ak_menu_item++;
                 while (ak_menu_pointer[ak_menu_item].action == action_bar)
                      ak_menu_item++;

                 if (ak_menu_pointer[ak_menu_item].action == end_menu)
                 {
                   ak_menu_item = 0;
                   while (ak_menu_pointer[ak_menu_item].action == action_bar)
                      ak_menu_item++;
                 }
              }
              else if (ch == up)
              {
                 if (ak_menu_item > 0)
                 {
                    ak_menu_item--;
                    while (ak_menu_pointer[ak_menu_item].action == action_bar &&
                           ak_menu_item > 0)
                      ak_menu_item--;

                    if (ak_menu_item == 0 && ak_menu_pointer[0].action == action_bar)
                    {
                       while (ak_menu_pointer[ak_menu_item].action == action_bar)
                          ak_menu_item++;
                    }
                 }
              }
           }
        }
}
