                        .386
                        .MODEL flat, c
ANZ_SPRITES EQU 111
SPRITE_MEM  EQU ANZ_SPRITES * 256

SC_INDEX       = 3c4h             ;Indexregister des Sequencer-Ctrl.
SC_MAP_MASK    = 2                ;Nummer des Map-Mask-Registers


externdef c anim_convert_table:byte
externdef c asm_sprite_start_vram:DWORD
externdef c grafik4planes:DWORD
externdef c asm_xaufl_feld:WORD
externdef c asm_step_feld:DWORD

externdef c draw_screenx:WORD
externdef c draw_screeny:WORD

externdef c schrift:DWORD
externdef c ascii_zs:BYTE

.CODE
;****************************************************************************
; Optimierungen fr graphics.cpp
;****************************************************************************

; Kopiert einen kompletten Bildschirm von VideoRam zu VideoRam
; (ModeX 4 Bytes auf einmal)

do_screen_copy_mode_x_1 PROC C USES esi edi, pix_pointer:DWORD,
                                feldstartpos:DWORD

                        LOCAL x_add:DWORD
                        sub ecx, ecx       ; Register auf Null setzen ;-)
                        sub edx, edx
                        sub eax, eax

                        mov ax, asm_xaufl_feld ; (Feldbreite
                        sub ax, draw_screenx   ; - Bildschirmbreite)
                        mul asm_step_feld      ; * Feldelementgre
                        mov x_add, eax         ; = x_add fr Feldpointer

                        mov edi, pix_pointer
                        mov ebx, feldstartpos

                        mov dh, byte ptr draw_screeny
                        .REPEAT
                           mov dl, byte ptr draw_screenx
                           push edi
                           .REPEAT
                              xor eax, eax
                              mov al, [ebx]   ; Hole Aussehen aktuelles Feld

                              .IF al < 10     ; Soll es animiert werden?
                                  mov al, anim_convert_table[eax]
                              .ENDIF

                              shl ax, 6       ; = ax * (256/4)

                              add ebx, asm_step_feld    ; feldzeiger weiterzhlen

                              add eax, asm_sprite_start_vram
                                                    ; auf eax sprite_start
                                                    ; (0a0000h + Start der
                                                    ; Sprites im VRAM)
                                                    ; draufaddieren
                              mov esi, eax          ; in ESI damit

                              mov cl, 16            ; Y-Blockgre 16
                              .REPEAT
                                 movsb              ; 4 Bytes mit einem
                                 movsb              ; movsb => X-Gre 16
                                 movsb
                                 movsb
                                 add edi, (320+16-16) / 4 ; in die nchste
                                                          ; Zeile
                                 dec cl
                              .UNTIL zero?
                              add edi, (16-(320+16)*16) / 4 ; Zurck auf erste
                                                          ; Zeile und einen
                                                          ; Block weiter nach
                                                          ; rechts
                              dec dl                ; x--
                           .UNTIL zero?
                           pop edi
                           add ebx, x_add           ; Im Feld eine Zeile tiefer
                           add edi, (320+16)*(16)/4 ; Im Bildschirm eine
                                                    ; Blockzeile tiefer
                           dec dh                   ; y--
                        .UNTIL zero?
                        ret                     ; Zack! Pat auf's !
do_screen_copy_mode_x_1 ENDP

; Kopiert einen kompletten Bildschirm vom Kernspeicher ins VideoRam

do_screen_copy_mode_x_2 PROC C USES esi edi, pix_pointer:DWORD,
                                feldstartpos:DWORD

                        LOCAL x_add:DWORD, sprite_start:DWORD

                        mov eax, grafik4planes
                        mov sprite_start, eax

                        sub ecx, ecx       ; Register auf Null setzen ;-)
                        sub edx, edx
                        sub eax, eax

                        mov ax, asm_xaufl_feld ; (Feldbreite
                        sub ax, draw_screenx        ; - Bildschirmbreite)
                        mul asm_step_feld      ; * Feldelementgre
                        mov x_add, eax         ; = x_add fr Feldpointer

                        mov cl, 0
                        .REPEAT
                           mov dx, SC_INDEX
                           mov al, SC_MAP_MASK
                           mov ah, 1
                           shl ah, cl
                           out dx, ax

                           mov edi, pix_pointer
                           mov ebx, feldstartpos

                           mov dh, byte ptr draw_screeny
                           .REPEAT
                              mov dl, byte ptr draw_screenx
                              push edi
                              .REPEAT
                                 xor eax, eax
                                 mov al, [ebx]   ; Hole Aussehen aktuelles Feld

                                 .IF al < 10     ; Soll es animiert werden?
                                     mov al, anim_convert_table[eax]
                                 .ENDIF

                                 shl ax, 6       ; = ax * (256/4)

                                 add ebx, asm_step_feld  ; feldzeiger weiterzhlen

                                 add eax, sprite_start ; auf eax sprite_start
                                                       ; draufaddieren
                                 mov esi, eax          ; in ESI damit

                                 mov ch, 16            ; Y-Blockgre 16
                                 .REPEAT
                                    movsd              ; 4 Bytes mit einem
                                                       ; movsd
                                    add edi, (320+16-16) / 4 ; in die nchste
                                                             ; Zeile
                                    dec ch
                                 .UNTIL zero?
                                 add edi, (16-(320+16)*16) / 4 ; Zurck auf erste
                                                             ; Zeile und einen
                                                             ; Block weiter nach
                                                             ; rechts
                                 dec dl                ; x--
                              .UNTIL zero?
                              pop edi
                              add ebx, x_add           ; Im Feld eine Zeile tiefer
                              add edi, (320+16)*(16)/4 ; Im Bildschirm eine
                                                       ; Blockzeile tiefer
                              dec dh                   ; y--
                           .UNTIL zero?

                           add sprite_start, SPRITE_MEM/4

                           inc cl
                        .UNTIL cl == 4

                        ret                     ; Zack! Pat auf's !
do_screen_copy_mode_x_2 ENDP

; Kopiert einen kompletten Bildschirm vom Kernspeicher ins VideoRam
; Low - Detail

do_screen_copy_mode_x_3 PROC C USES esi edi, pix_pointer:DWORD,
                                feldstartpos:DWORD

                        LOCAL x_add:DWORD, sprite_start:DWORD

                        mov eax, grafik4planes
                        mov sprite_start, eax

                        sub ecx, ecx       ; Register auf Null setzen ;-)
                        sub edx, edx
                        sub eax, eax

                        mov ax, asm_xaufl_feld ; (Feldbreite
                        sub ax, draw_screenx        ; - Bildschirmbreite)
                        mul asm_step_feld      ; * Feldelementgre
                        mov x_add, eax         ; = x_add fr Feldpointer


                        mov cl, 0
                        .REPEAT
                           mov dx, SC_INDEX
                           mov al, SC_MAP_MASK
                           mov ah, 11b
                           shl ah, cl
                           out dx, ax

                           mov edi, pix_pointer
                           mov ebx, feldstartpos

                           mov dh, byte ptr draw_screeny
                           .REPEAT
                              mov dl, byte ptr draw_screenx
                              push edi
                              .REPEAT
                                 xor eax, eax
                                 mov al, [ebx]   ; Hole Aussehen aktuelles Feld

                                 .IF al < 10     ; Soll es animiert werden?
                                     mov al, anim_convert_table[eax]
                                 .ENDIF

                                 shl ax, 6       ; = ax * (256/4)

                                 add ebx, asm_step_feld  ; feldzeiger weiterzhlen

                                 add eax, sprite_start ; auf eax sprite_start
                                                       ; draufaddieren
                                 mov esi, eax          ; in ESI damit

                                 mov ch, 16            ; Y-Blockgre 16
                                 .REPEAT
                                    movsd              ; 4 Bytes mit einem
                                                       ; movsd
                                    add edi, (320+16-16) / 4 ; in die nchste
                                                             ; Zeile
                                    dec ch
                                 .UNTIL zero?
                                 add edi, (16-(320+16)*16) / 4 ; Zurck auf erste
                                                             ; Zeile und einen
                                                             ; Block weiter nach
                                                             ; rechts
                                 dec dl                ; x--
                              .UNTIL zero?
                              pop edi
                              add ebx, x_add           ; Im Feld eine Zeile tiefer
                              add edi, (320+16)*(16)/4 ; Im Bildschirm eine
                                                       ; Blockzeile tiefer
                              dec dh                   ; y--
                           .UNTIL zero?

                           add sprite_start, (SPRITE_MEM*2)/4

                           inc cl
                           inc cl
                        .UNTIL cl == 4

                        ret                     ; Zack! Pat auf's !
do_screen_copy_mode_x_3 ENDP

setze_sprite_asm        PROC C USES esi edi, quelle:DWORD, ziel:DWORD,
                                xaufl:DWORD, yaufl:DWORD,
                                startplane:BYTE,
                                trans_farbe:BYTE

                        LOCAL x_add:DWORD

                        mov eax, (320+16)/4
                        sub eax, xaufl
                        mov x_add, eax

                        mov cl, startplane

                        mov bh, trans_farbe

                        mov bl, 4
                        .REPEAT
                            push ecx
                            mov esi, quelle
                            inc quelle
                            mov edi, ziel

                            mov dx, SC_INDEX
                            mov al, SC_MAP_MASK
                            mov ah, 1
                            shl ah, cl
                            out dx, ax

                            mov edx, yaufl
                            .REPEAT
                                mov ecx, xaufl
                                .REPEAT
                                    lodsd    ; nimm vier, verwerte eins ;-)
                                    .IF !(al == bh)
                                        mov [edi],al
                                    .ENDIF
                                    inc edi
                                    dec ecx
                                .UNTIL zero?
                                add edi, x_add
                                dec edx
                            .UNTIL zero?
                            pop ecx
                            inc cl
                            .IF cl == 4
                                inc ziel
                                and cl, 3
                            .ENDIF
                            dec bl
                        .UNTIL zero?
                        ret
setze_sprite_asm        ENDP

;****************************************************************************
; Optimierungen fr flames.cpp
;****************************************************************************
print_big_string_schatten_asm PROC C USES esi edi, quellstring:DWORD,
                                      zielbuffer:DWORD,
                                      bufferxaufl:DWORD

                        LOCAL x_add:DWORD, y_add:DWORD

                        mov edx, quellstring
                        mov ebx, offset ascii_zs
                        mov edi, zielbuffer

                        mov eax, bufferxaufl
                        sub eax, 16
                        mov x_add, eax

                        mov eax, bufferxaufl
                        shl eax, 4
                        neg eax
                        add eax, 8
                        mov y_add, eax

                        sub eax, eax

                        .WHILE 1
                           mov al, [edx]
                           inc edx
                           .IF al == 0
                               .BREAK
                           .ELSEIF al != ' '
                               xlatb
                               xchg al,ah    ; * 256
                               add eax, schrift
                               mov esi, eax
                               sub eax, eax

                               mov ch, 16
                               .REPEAT
                                   mov cl, 16
                                   .REPEAT
                                       lodsb
                                       .IF al != 0
                                           mov [edi], ah
                                       .ENDIF
                                       inc edi
                                       dec cl
                                   .UNTIL zero?
                                   add edi, x_add
                                   dec ch
                               .UNTIL zero?
                               add edi, y_add
                           .ENDIF
                           add edi, 8
                        .ENDW
                        ret
print_big_string_schatten_asm ENDP
print_big_string_flames_asm PROC C USES esi edi, quellstring:DWORD,
                                      flamebuffer:DWORD,
                                      flamexaufl:DWORD,
                                      flameyaufl:DWORD,
                                      zielbuffer:DWORD,
                                      bufferxaufl:DWORD

                        LOCAL x_add:DWORD, y_add:DWORD,
                              x_add_flames:DWORD, flame_start:DWORD

                        mov edi, zielbuffer

                        mov eax, bufferxaufl
                        sub eax, 16
                        mov x_add, eax

                        mov eax, bufferxaufl
                        shl eax, 4
                        neg eax
                        add eax, 8
                        mov y_add, eax

                        mov eax, flamexaufl
                        add eax, 16
                        neg eax
                        mov x_add_flames, eax

                        mov eax, flameyaufl
                        sub eax, 2
                        mul flamexaufl
                        add eax, 2
                        add eax, flamebuffer
                        mov flame_start, eax

                        sub eax, eax
                        mov edx, quellstring

                        .WHILE 1
                           mov al, [edx]
                           inc edx
                           .IF al == 0
                               .BREAK
                           .ELSEIF al != ' '
                               mov al, ascii_zs[eax]
                               xchg al,ah    ; * 256
                               add eax, schrift
                               mov esi, eax
                               sub eax, eax

                               mov ebx, flame_start

                               mov ch, 16
                               .REPEAT
                                   mov cl, 16
                                   .REPEAT
                                       lodsb
                                       .IF al != 0
                                           mov al, [ebx]
                                           and al, 31
                                          ; .IF al > 25
                                          ;     mov al, 25
                                          ; .ENDIF
                                           add al,128-16
                                           mov [edi], al
                                       .ENDIF
                                       inc ebx
                                       inc edi
                                       dec cl
                                   .UNTIL zero?
                                   add ebx, x_add_flames
                                   add edi, x_add
                                   dec ch
                               .UNTIL zero?
                               add edi, y_add
                           .ENDIF
                           add edi, 8
                        .ENDW
                        ret
print_big_string_flames_asm ENDP

                        END
